#include "Depth_Histogram.h"

CDepth_Hitogram::CDepth_Hitogram(void)
{
}

CDepth_Hitogram::~CDepth_Hitogram(void)
{
}


//Initialization
int CDepth_Hitogram::Init(){
	
	int i, j, m, n, count = 0;

	bpp = 1;
	WStep = SET_X_SIZE;

	//Area size histogram calculation
	for(i=HIST_AREA; i<=SET_X_SIZE; i=i+WIDTH_STEP){
		//Histogram area sliding
		for(n=0; n<=SET_Y_SIZE-i; n=n+SLIDE_STEP){
			for(m=0; m<=SET_X_SIZE-i; m=m+SLIDE_STEP){
				count++;
			}
		}
	}

	CellNum = count;

	Depth_Hist = new double *[count];
	for(i=0; i<count; i++){

		Depth_Hist[i] = new double [DEPTH_HIST_BIN];
	}

	return 0;
}


//Integral depth histogram calculation
int CDepth_Hitogram::CompIntegralDepthHist(int imgSource[]){


int i, m, n, x, y, z;
	int a, b, c, d;
	int sum = 0;
	int count = 0;
	int BinValue;
	int IntegralDepthHisto[(SET_X_SIZE + 1) * (SET_Y_SIZE + 1)][DEPTH_HIST_BIN];
	double normalize = 0.0;

	double coefficient = (double)(DEPTH_HIST_BIN-1)/255.0;
	double aa;
	
	//Initialization of array
	memset(IntegralDepthHisto,0,sizeof(IntegralDepthHisto));

	//y-axis movement
	for(y=1;y<SET_Y_SIZE+1;y++){
		//x-axis movement
		for(x=1;x<SET_X_SIZE+1;x++){

			//Depth quantization
			aa = coefficient * (double)imgSource[(y-1)*WStep + (x-1)];
			BinValue = aa;
			if(0.5 < aa - BinValue)		BinValue++;

			//Creating depth histogram
			IntegralDepthHisto[(y)*(WStep+1) + (x)][BinValue] = 1;
		}
	}

	//Createing Integral depth histogram

	//added in the x direction
	for(z=0; z<DEPTH_HIST_BIN; z++){
		for(y=1; y<SET_Y_SIZE+1; y++){
			for(x=2; x<SET_X_SIZE+1; x++){

				IntegralDepthHisto[(y)*(WStep+1) + (x)][z] = IntegralDepthHisto[(y)*(WStep+1) + (x)][z] + IntegralDepthHisto[(y)*(WStep+1) + (x-1)][z];

			}
		}
	}

	//added in the y direction
	for(z=0; z<DEPTH_HIST_BIN; z++){
		for(y=2; y<SET_Y_SIZE+1; y++){
			for(x=1; x<SET_X_SIZE+1; x++){

				IntegralDepthHisto[(y)*(WStep+1) + (x)][z] = IntegralDepthHisto[(y)*(WStep+1) + (x)][z] + IntegralDepthHisto[(y-1)*(WStep+1) + (x)][z];

			}
		}
	}

	count = 0;
	//Area size histogram calculation
	for(i=HIST_AREA; i<=SET_X_SIZE; i=i+WIDTH_STEP){
		for(n=1; n<=SET_Y_SIZE-i+1; n=n+SLIDE_STEP){
			for(m=1; m<=SET_X_SIZE-i+1; m=m+SLIDE_STEP){

				normalize = 0.0;
				//Moving depth histogram bin
				for(z=0; z<DEPTH_HIST_BIN; z++){
					a = IntegralDepthHisto[(n-1)*(WStep+1) + (m-1)][z];
					b = IntegralDepthHisto[((n-1)+(i))*(WStep+1) + ((m-1)+(i))][z];
					c = IntegralDepthHisto[(n-1)*(WStep+1) + ((m-1)+(i))][z];
					d = IntegralDepthHisto[((n-1)+(i))*(WStep+1) + (m-1)][z];
					Depth_Hist[count][z] = (double)((a + b) - (c + d));
					normalize = normalize + (double)((a + b) - (c + d));

				}
				//Histogram normalization
				for(z=0; z<DEPTH_HIST_BIN; z++){
					Depth_Hist[count][z] = Depth_Hist[count][z] / normalize;
				}
				count++;
			}
		}
	}

	return 0;
}


//Calculation of the depth histogram feature
int CDepth_Hitogram::GetHistogramfeature(double hog_feature[]){

	int i, j, z, count = (ALL_FEATURE - DEPTH_FEATURE);
	double Bhattacharyya = 0.0;

	//Similarity is calculated from a combination of all cells
	for(i=0; i<CellNum-1; i++){
		for(j=i+1; j<CellNum; j++){

			//Bhattacharyya distance is calculated
			Bhattacharyya = 0.0;
			for(z=0; z<DEPTH_HIST_BIN; z++){

				Bhattacharyya = Bhattacharyya + sqrt(Depth_Hist[i][z] * Depth_Hist[j][z]);
			}

			hog_feature[count] = Bhattacharyya;
			count++;
		}
	}

	return 0;
}