#include <stdio.h>
#include <string.h>
#include "learning.h"
#include "Depth_Histogram.h"
#include "common.h"

int onFileOpen(int count);

Clearning			ob_LEARN;
CDepth_Hitogram		ob_Depth_Histogram;

int *imgDepthLowSource = new int[SET_X_SIZE * SET_Y_SIZE];

int main(){
	int i, key;
	double* descriptor = new double[ALL_FEATURE];

	//Init
	ob_LEARN.Init();

	//Init
	ob_Depth_Histogram.Init();

	printf("-------------------------------------------\n");

	for(i=0;i<FILE_NUM;i++){

		printf("feature extraction : %7d / %d\r", i, FILE_NUM);

		//Input file
		onFileOpen(i);

		//Create histograms
		ob_Depth_Histogram.CompIntegralDepthHist(imgDepthLowSource);

		//Feature extraction
		ob_Depth_Histogram.GetHistogramfeature(descriptor);

		//Feature stock
		ob_LEARN.FeatureStock(descriptor,i);
	}

	printf("\nFinished feature extraction\n");
	printf("-------------------------------------------\n");
	printf("Start learningII\n");

	ob_LEARN.RealAdaBoost();

	delete [] imgDepthLowSource;
	delete [] descriptor;

	return 0;
}

int onFileOpen(int count){

	FILE *fp;
	int i, j, value;
	char fname[200];    // filename

	//Input depth data
	if(count<POS_FILE){
		sprintf_s(fname, "%sf_%07d.dat",INPUT_POS_DEPTH_DIR, count);
	}else{
		sprintf_s(fname, "%sf_%07d.dat",INPUT_NEG_DEPTH_DIR, count - POS_FILE);
	}

	if((fp = fopen(fname, "r")) == NULL){
		printf("Can not input dataII\n");
		getchar();
		exit(1);
	}
	
	while(1){

		if(EOF == (fscanf(fp, "%d %d %d\n", &i, &j, &value))){
			break;
		}
		imgDepthLowSource[(j)*SET_X_SIZE + (i)] = value;

	}

	fclose(fp);

	return 0;
}
