#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "Depth_Histogram.h"

#define OUTPUT_DIR				"./OUTPUT/LUT/"					//Directory to contain the probability density distribution
#define DEPTH_FEATURE			120786							//Number of the RDSFs
#define ALL_FEATURE				(DEPTH_FEATURE)					//ALL features
#define POS_FILE				1346							//Sample number of positive
#define NEG_FILE				10000							//Sample number of negative
#define EPSILON					0.0000000001					//Error avoidance
#define FILE_NUM				(POS_FILE + NEG_FILE)			//Number of learning samples
#define LEARNING_NUM			1000							//Learning times
#define TH						0.0
#define BIN						32								//Number of bins probability density

#define POS						1
#define NEG						0
#define TRUE					1
#define FALSE					0

#define TEST													//Training samples for classification


//If the output argument is zero or 1, and 0 otherwise is less than zero, otherwise 1
#define SIGN(val)	((val == 0) ? 1 : (val < 0) ? 0 : 1)

class Clearning
{
public:
	/* Weak hypothesis */
	typedef struct{
		int number;		//The number of histogram probabilities
		double z;		//Error rate(0.0`1.0)
	}Classifier;

public:
	Clearning(void);
	~Clearning(void);
	int Init();
	double Prediction(int number,int count,double lut[][2]);
	double Prediction2(int learn_number,int count);
	int ClassifierTest(int learn);
	double Classification(double lut[][2]);
	int SelectClassifier(Classifier *cl,double lut[][2]);
	int DataWeightUpdate(int number,double lut[][2]);
	int WrightData(Classifier *cl,double lut[][2],int leran);
	int Learning(int leran);
	int DataWeightInit();
	int RealAdaBoost();
	int FeatureStock(double hog_descriptor[ALL_FEATURE],int count);
	int Comp_Hist(int number,double lut[][2]);
	int OutPutHist(double lut[][2],int leran);
	int SelectFile();
	int SmoothingLUT(double lut[][2]);

private:
	double  Evaluated_Value;
	//double	m_feature[FILE_NUM][ALL_FEATURE];
	double	**m_feature;
	double  m_weight[FILE_NUM];
//#ifdef TEST 
	double  m_lut[LEARNING_NUM][BIN][2];
	int		m_number[LEARNING_NUM];
//#endif

};